// Wave sound comression algorithm
#include "../Compression.h"
#include "ttaenc.h"


#ifdef __cplusplus

//      COMPRESSION_METHOD
class TTA_METHOD : public COMPRESSION_METHOD
{
public:
  //    
  int level;        // Compression level (1..3, higher means tighter and slower compression)
  int skip_header;  // Skip WAV header detection
  int is_float;     // Floating-point data format
  int num_chan;     // Channels count
  int word_size;    // Size of each encoded value, in bits
  int offset;       // File offset where MM data start (header is copied intact)
  int raw_data ;    // Write raw predictor's output without using entropy encoder

  // ,       
  TTA_METHOD();

  //    
  virtual int decompress (CALLBACK_FUNC *callback, void *auxdata);
#ifndef FREEARC_DECOMPRESS_ONLY
  virtual int compress   (CALLBACK_FUNC *callback, void *auxdata);

  //   buf[MAX_METHOD_STRLEN] ,       (,   parse_TTA)
  virtual void ShowCompressionMethod (char *buf);

  // /  ,   /,     
  virtual MemSize GetCompressionMem     (void)         {return 2*mb;}
  virtual MemSize GetDecompressionMem   (void)         {return 1*mb;}
  virtual MemSize GetDictionary         (void)         {return 0;}
  virtual MemSize GetBlockSize          (void)         {return 0;}
  virtual void    SetCompressionMem     (MemSize mem)  {}
  virtual void    SetDecompressionMem   (MemSize mem)  {}
  virtual void    SetDictionary         (MemSize dict) {}
  virtual void    SetBlockSize          (MemSize bs)   {}
#endif
};

//     TTA
COMPRESSION_METHOD* parse_TTA (char** parameters);

#endif  // __cplusplus
